summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorNicolas Vigier <boklm@mageia.org>2012-02-05 22:33:21 +0000
committerNicolas Vigier <boklm@mageia.org>2012-02-05 22:33:21 +0000
commitfb61eb7a24fa86d5503afb6b318e12423d182645 (patch)
tree98874084bad57d15e32734a70251ec8566a7c06e
add mgasoft first version
-rw-r--r--COPYING121
-rwxr-xr-xmgasoft185
-rwxr-xr-xmgasoft-publish67
-rw-r--r--mgasoft.conf6
4 files changed, 379 insertions, 0 deletions
diff --git a/COPYING b/COPYING
new file mode 100644
index 0000000..0e259d4
--- /dev/null
+++ b/COPYING
@@ -0,0 +1,121 @@
+Creative Commons Legal Code
+
+CC0 1.0 Universal
+
+ CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
+ LEGAL SERVICES. DISTRIBUTION OF THIS DOCUMENT DOES NOT CREATE AN
+ ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS
+ INFORMATION ON AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES
+ REGARDING THE USE OF THIS DOCUMENT OR THE INFORMATION OR WORKS
+ PROVIDED HEREUNDER, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING FROM
+ THE USE OF THIS DOCUMENT OR THE INFORMATION OR WORKS PROVIDED
+ HEREUNDER.
+
+Statement of Purpose
+
+The laws of most jurisdictions throughout the world automatically confer
+exclusive Copyright and Related Rights (defined below) upon the creator
+and subsequent owner(s) (each and all, an "owner") of an original work of
+authorship and/or a database (each, a "Work").
+
+Certain owners wish to permanently relinquish those rights to a Work for
+the purpose of contributing to a commons of creative, cultural and
+scientific works ("Commons") that the public can reliably and without fear
+of later claims of infringement build upon, modify, incorporate in other
+works, reuse and redistribute as freely as possible in any form whatsoever
+and for any purposes, including without limitation commercial purposes.
+These owners may contribute to the Commons to promote the ideal of a free
+culture and the further production of creative, cultural and scientific
+works, or to gain reputation or greater distribution for their Work in
+part through the use and efforts of others.
+
+For these and/or other purposes and motivations, and without any
+expectation of additional consideration or compensation, the person
+associating CC0 with a Work (the "Affirmer"), to the extent that he or she
+is an owner of Copyright and Related Rights in the Work, voluntarily
+elects to apply CC0 to the Work and publicly distribute the Work under its
+terms, with knowledge of his or her Copyright and Related Rights in the
+Work and the meaning and intended legal effect of CC0 on those rights.
+
+1. Copyright and Related Rights. A Work made available under CC0 may be
+protected by copyright and related or neighboring rights ("Copyright and
+Related Rights"). Copyright and Related Rights include, but are not
+limited to, the following:
+
+ i. the right to reproduce, adapt, distribute, perform, display,
+ communicate, and translate a Work;
+ ii. moral rights retained by the original author(s) and/or performer(s);
+iii. publicity and privacy rights pertaining to a person's image or
+ likeness depicted in a Work;
+ iv. rights protecting against unfair competition in regards to a Work,
+ subject to the limitations in paragraph 4(a), below;
+ v. rights protecting the extraction, dissemination, use and reuse of data
+ in a Work;
+ vi. database rights (such as those arising under Directive 96/9/EC of the
+ European Parliament and of the Council of 11 March 1996 on the legal
+ protection of databases, and under any national implementation
+ thereof, including any amended or successor version of such
+ directive); and
+vii. other similar, equivalent or corresponding rights throughout the
+ world based on applicable law or treaty, and any national
+ implementations thereof.
+
+2. Waiver. To the greatest extent permitted by, but not in contravention
+of, applicable law, Affirmer hereby overtly, fully, permanently,
+irrevocably and unconditionally waives, abandons, and surrenders all of
+Affirmer's Copyright and Related Rights and associated claims and causes
+of action, whether now known or unknown (including existing as well as
+future claims and causes of action), in the Work (i) in all territories
+worldwide, (ii) for the maximum duration provided by applicable law or
+treaty (including future time extensions), (iii) in any current or future
+medium and for any number of copies, and (iv) for any purpose whatsoever,
+including without limitation commercial, advertising or promotional
+purposes (the "Waiver"). Affirmer makes the Waiver for the benefit of each
+member of the public at large and to the detriment of Affirmer's heirs and
+successors, fully intending that such Waiver shall not be subject to
+revocation, rescission, cancellation, termination, or any other legal or
+equitable action to disrupt the quiet enjoyment of the Work by the public
+as contemplated by Affirmer's express Statement of Purpose.
+
+3. Public License Fallback. Should any part of the Waiver for any reason
+be judged legally invalid or ineffective under applicable law, then the
+Waiver shall be preserved to the maximum extent permitted taking into
+account Affirmer's express Statement of Purpose. In addition, to the
+extent the Waiver is so judged Affirmer hereby grants to each affected
+person a royalty-free, non transferable, non sublicensable, non exclusive,
+irrevocable and unconditional license to exercise Affirmer's Copyright and
+Related Rights in the Work (i) in all territories worldwide, (ii) for the
+maximum duration provided by applicable law or treaty (including future
+time extensions), (iii) in any current or future medium and for any number
+of copies, and (iv) for any purpose whatsoever, including without
+limitation commercial, advertising or promotional purposes (the
+"License"). The License shall be deemed effective as of the date CC0 was
+applied by Affirmer to the Work. Should any part of the License for any
+reason be judged legally invalid or ineffective under applicable law, such
+partial invalidity or ineffectiveness shall not invalidate the remainder
+of the License, and in such case Affirmer hereby affirms that he or she
+will not (i) exercise any of his or her remaining Copyright and Related
+Rights in the Work or (ii) assert any associated claims and causes of
+action with respect to the Work, in either case contrary to Affirmer's
+express Statement of Purpose.
+
+4. Limitations and Disclaimers.
+
+ a. No trademark or patent rights held by Affirmer are waived, abandoned,
+ surrendered, licensed or otherwise affected by this document.
+ b. Affirmer offers the Work as-is and makes no representations or
+ warranties of any kind concerning the Work, express, implied,
+ statutory or otherwise, including without limitation warranties of
+ title, merchantability, fitness for a particular purpose, non
+ infringement, or the absence of latent or other defects, accuracy, or
+ the present or absence of errors, whether or not discoverable, all to
+ the greatest extent permissible under applicable law.
+ c. Affirmer disclaims responsibility for clearing rights of other persons
+ that may apply to the Work or any use thereof, including without
+ limitation any person's Copyright and Related Rights in the Work.
+ Further, Affirmer disclaims responsibility for obtaining any necessary
+ consents, permissions or other rights required for any use of the
+ Work.
+ d. Affirmer understands and acknowledges that Creative Commons is not a
+ party to this document and has no duty or obligation with respect to
+ this CC0 or use of the Work.
diff --git a/mgasoft b/mgasoft
new file mode 100755
index 0000000..3578a70
--- /dev/null
+++ b/mgasoft
@@ -0,0 +1,185 @@
+#!/bin/sh
+
+# To the extent possible under law, the author(s) have dedicated all
+# copyright and related and neighboring rights to this software to the
+# public domain worldwide.
+# This software is distributed without any warranty.
+
+# You should have received a copy of the CC0 Public Domain Dedication
+# along with this software.
+# If not, see <http://creativecommons.org/publicdomain/zero/1.0/>.
+
+. /etc/mgasoft.conf
+
+function check_softname()
+{
+ local softname="$1"
+ test -n "$softname" || return 1
+ echo "$softname" | fgrep -q .. && return 1
+ echo "$softname" | fgrep -q / && return 1
+ return 0
+}
+
+function check_softrel()
+{
+ check_softname $@
+}
+
+function usage()
+{
+ local cmd="$1"
+ local exitval=$2
+ case "$cmd" in
+ tagrelease)
+ cat <<EOF
+Usage: mgasoft tag [name] [version]
+
+This command tag a version from trunk.
+EOF
+ ;;
+ gettar)
+ cat <<EOF
+Usage: mgasoft tar [name] [version]
+
+This command will create a tarball.
+EOF
+ ;;
+ publish)
+ cat <<EOF
+Usage: mgasoft publish [name] [version]
+
+This command will publish a version on mageia mirrors.
+EOF
+ ;;
+ *)
+ cat <<EOF
+Usage: mgasoft [command] [args]
+
+Available commands :
+ tag
+ publish
+ tar
+
+For more infos about a command, use :
+ mgasoft [command] --help
+EOF
+ ;;
+esac
+ exit $exitval
+}
+
+function tagrelease()
+{
+ [ "$1" == "--help" ] && usage tagrelease 0
+ [ $# -ne 2 ] && usage tagrelease 1
+ local softname="$1"
+ local softrel="$2"
+ check_softname "$softname" || exit 1
+ check_softrel "$softrel" || exit 1
+
+ local softdir="$svn_soft/$softname"
+
+ if ! svn ls "$softdir/trunk" > /dev/null 2>&1
+ then
+ echo "error: $softname does not exists" >&2
+ exit 2
+ fi
+
+ if svn ls "$softdir/tags/$softrel" > /dev/null 2>&1
+ then
+ echo "error: $softname version $softrel already exists" >&2
+ exit 2
+ fi
+
+ if ! svn ls "$softdir/tags" > /dev/null 2>&1
+ then
+ svn mkdir -q -m "create tags directory for $softname" "$softdir/tags"
+ fi
+ svn cp -q -m "tag $softname version $softrel" "$softdir/trunk" "$softdir/tags/$softrel"
+}
+
+function gettar()
+{
+ [ "$1" == "--help" ] && usage gettar 0
+ [ $# -ne 2 ] && usage gettar 1
+ local softname="$1"
+ local softrel="$2"
+ check_softname "$softname" || exit 1
+ check_softrel "$softrel" || exit 1
+
+ local oldpwd=$PWD
+ local tmpdir=$(mktemp -d)
+ cd $tmpdir
+ if [ "$softrel" == "trunk" ]
+ then
+ local svnpath="$anonsvn_soft/$softname/trunk"
+ else
+ local svnpath="$anonsvn_soft/$softname/tags/$softrel"
+ fi
+ if ! svn export -q "$svnpath" "$softname-$softrel"
+ then
+ echo "Error exporting $softname-$softrel" >&2
+ rm -Rf "$tmpdir"
+ exit 2
+ fi
+ tar cvJf "$oldpwd/$softname-$softrel.tar.xz" "$softname-$softrel"
+ cd "$oldpwd"
+ rm -Rf "$tmpdir"
+ echo "Created $softname-$softrel.tar.xz"
+}
+
+function publishrelease()
+{
+ [ "$1" == "--help" ] && usage publish 0
+ [ $# -ne 2 ] && usage publish 1
+ local softname="$1"
+ local softrel="$2"
+ check_softname "$softname" || exit 1
+ check_softrel "$softrel" || exit 1
+
+ local svnpath="$svn_soft/$softname/tags/$softrel"
+ if ! svn ls "$svnpath" > /dev/null 2>&1
+ then
+ echo "error: $softname version $softrel does not exist" >&2
+ exit 2
+ fi
+
+ local pubdir="$svn_soft_publish/$softname"
+ if svn ls "$pubdir/$softrel" > /dev/null 2>&1
+ then
+ echo "$softname version $softrel already published" >&2
+ exit 2
+ fi
+ if ! svn ls "$pubdir" > /dev/null 2>&1
+ then
+ svn mkdir -q -m "create directory for $softname" "$pubdir"
+ fi
+ local tmpdir=$(mktemp -d)
+ pushd "$tmpdir" > /dev/null
+ svn co -q "$pubdir"
+ cd "$softname"
+ touch "$softrel"
+ svn add -q "$softrel"
+ svn ci -q -m "publish $softname version $softrel"
+ popd > /dev/null
+ rm -Rf "$tmpdir"
+}
+
+case "$1" in
+ tag)
+ shift
+ tagrelease $@
+ ;;
+ tar)
+ shift
+ gettar $@
+ ;;
+ publish)
+ shift
+ publishrelease $@
+ ;;
+ *)
+ usage '' 1
+ ;;
+esac
+
diff --git a/mgasoft-publish b/mgasoft-publish
new file mode 100755
index 0000000..732fe45
--- /dev/null
+++ b/mgasoft-publish
@@ -0,0 +1,67 @@
+#!/bin/sh
+
+# To the extent possible under law, the author(s) have dedicated all
+# copyright and related and neighboring rights to this software to the
+# public domain worldwide.
+# This software is distributed without any warranty.
+
+# You should have received a copy of the CC0 Public Domain Dedication
+# along with this software.
+# If not, see <http://creativecommons.org/publicdomain/zero/1.0/>.
+
+. /etc/mgasoft.conf
+
+function check_softname()
+{
+ local softname="$1"
+ test -n "$softname" || return 1
+ echo "$softname" | fgrep -q .. && return 1
+ echo "$softname" | fgrep -q / && return 1
+ return 0
+}
+
+function check_softrel()
+{
+ check_softname $@
+}
+
+function update_infos()
+{
+ pushd $pubinfodir > /dev/null || exit 3
+ svn up -q
+ popd > /dev/null || exit 3
+}
+
+function publish()
+{
+ local softname="$1"
+ local softrel="$2"
+ check_softname "$softname" || return 1
+ check_softrel "$softrel" || return 1
+ pushd "$pubmirrordir/$softname" > /dev/null || exit 3
+ mgasoft tar "$softname" "$softrel"
+ #TODO: sign file
+ #TODO: upload to binrepo
+ #TODO: update sha1sum in pubinfodir
+ popd > /dev/null || exit 3
+}
+
+update_infos
+pushd "$pubinfodir" > /dev/null
+for softname in *
+do
+ pushd "$softname" > /dev/null || exit 3
+ for rel in *
+ do
+ if ! [ -d "$pubmirrordir/$softname" ]
+ then
+ mkdir "$pubmirrordir/$softname"
+ fi
+ if ! [ -f "$pubmirrordir/$softname/$softname-$rel.tar.xz" ]
+ then
+ publish "$softname" "$rel"
+ fi
+ done
+ popd > /dev/null || exit 3
+done
+popd > /dev/null
diff --git a/mgasoft.conf b/mgasoft.conf
new file mode 100644
index 0000000..61c8514
--- /dev/null
+++ b/mgasoft.conf
@@ -0,0 +1,6 @@
+svn_soft=svn+ssh://svn.mageia.org/svn/soft
+anonsvn_soft=svn://svn.mageia.org/svn/soft
+svn_soft_publish=svn+ssh://svn.mageia.org/svn/soft_publish
+
+#pubinfodir=/var/lib/mgasoft/infos
+#pubmirrordir=/distrib/mirrors/aaa